#ifndef _MENU_HELPER_
#define _MENU_HELPER_

#include <Application.h>
#include <Window.h>
#include <MenuBar.h>
#include <MenuItem.h>
#include <Rect.h>

// definitions
#define MAX_MENU_STRING_LEN 32
#define SEPERATOR "-"


// structure definitions
typedef struct
{
	char 		m_szMenuItemText[MAX_MENU_STRING_LEN];
	uint32 		m_uiMessageID;
	char 		m_cShortcut;
	uint32 		m_modifiers;
	uint32 *	m_pSubMenu;
	
}MH_MENUITEM;

typedef struct 
{
	char 			m_szMenuTitle[MAX_MENU_STRING_LEN];
	MH_MENUITEM * 	m_pMenuItems;	

}MH_MENU;


// function prototypes
BMenuBar * CreateMenuBar(MH_MENU * pMenuArray); 
BMenu * CreateMenu(char * pMenuTitle, MH_MENUITEM * pMenu);

#endif // _MENU_HELPER_