#include "MenuHelper.h"



BMenuBar * CreateMenuBar(MH_MENU * pMenuArray)
{
	// variables
	MH_MENU * pMenuList;
	MH_MENUITEM * pMenuItemIn;
	BMenu* pMenu;
	BMenu* pSubMenu;

	// Create an empty MenuBar
	BMenuBar * pMenubar;
	BRect dummyFrame(0, 0, 0, 0);
	pMenubar = new BMenuBar(dummyFrame, "Full Menu Bar");
	
	// initialize to start of MenuBar Array
	pMenuList = pMenuArray;
	pMenuItemIn = pMenuArray->m_pMenuItems;
	
	// While there are Menus left to make...
	while (strcmp(pMenuList->m_szMenuTitle,"") != 0)
	{
		pMenu = new BMenu(pMenuList->m_szMenuTitle);

		// While there are MenuItems left to make...		
		while (strcmp(pMenuItemIn->m_szMenuItemText,"") != 0)
		{
			//pMenuItemIn->pMenuItems	
	
			// if menuitem is a SEPERATOR
			if ( strcmp(pMenuItemIn->m_szMenuItemText,(char *)SEPERATOR) == 0 )
			{
				pMenu->AddSeparatorItem();
				
			} // if menuitem is actually another menu level 
			else if ( pMenuItemIn->m_uiMessageID == 0 )
			{
				pSubMenu = CreateMenu(pMenuItemIn->m_szMenuItemText, (MH_MENUITEM *)pMenuItemIn->m_pSubMenu);
				pMenu->AddItem(pSubMenu);
				
			} // if menuitem actually is a menuitem, creat it
			else
			{
				BMenuItem* pNewMenuItem = new BMenuItem(pMenuItemIn->m_szMenuItemText, 
														new BMessage(pMenuItemIn->m_uiMessageID),
														pMenuItemIn->m_cShortcut,
														pMenuItemIn->m_modifiers);	
				pNewMenuItem->SetTarget(be_app);			
				pMenu->AddItem(pNewMenuItem);
			}
			// advance menuitem pointer
			pMenuItemIn++;	
		}
		// add menu to menubar
		pMenubar->AddItem(pMenu);
		
		// advance menu list
		pMenuList++;
		pMenuItemIn = pMenuList->m_pMenuItems;
	}
	

	// return pointer to menubar
	return pMenubar;

}

// re-entrant function to create sub menus
BMenu * CreateMenu(char * pMenuTitle, MH_MENUITEM * pMenu)
{
	MH_MENUITEM * pMenuItemIn = pMenu;
	
	BMenu * pNewMenu = new BMenu(pMenuTitle);
	BMenu * pSubMenu;

	// While there are MenuItems left to make...		
	while (strcmp(pMenuItemIn->m_szMenuItemText,"") != 0)
	{
		
		// if menuitem is a SEPERATOR
		if ( strcmp(pMenuItemIn->m_szMenuItemText,(char *)SEPERATOR) == 0 )
		{
			pNewMenu->AddSeparatorItem();
				
		} // if menuitem is actually another menu level 
		else if ( pMenuItemIn->m_uiMessageID == 0 )
		{
			pSubMenu = CreateMenu(pMenuItemIn->m_szMenuItemText, (MH_MENUITEM *)pMenuItemIn->m_pSubMenu);		
			pNewMenu->AddItem(pSubMenu);
			
		} // if menuitem is actually a menutitem, create it 
		else
		{
			BMenuItem* pNpkgItem = new BMenuItem(pMenuItemIn->m_szMenuItemText, 
													new BMessage(pMenuItemIn->m_uiMessageID),
													pMenuItemIn->m_cShortcut,
													pMenuItemIn->m_modifiers);	
			pNpkgItem->SetTarget(be_app);			
			pNewMenu->AddItem(pNpkgItem);
		}
		
		// advance to next menuitem	
		pMenuItemIn++;	
	}
	
	// return pointer to menu		
	return pNewMenu;
}
